package com.simonstl.fragment;

import java.util.LinkedList;
/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The BufferStack class stores a stack of StringBuffer values so that the {@link com.simonstl.fragment.FragmentFilter FragmentFilter}
* can keep track of multiple buffers during multi-level fragmentation. </p>
*
* <p>It is designed to allow the <code>BufferStack</code> to be treated as a <code>StringBuffer</code>.</p>
*
* @version 0.01 22 June 2001
* @author Simon St.Laurent
*/

public class BufferStack {
     private LinkedList stack;

public BufferStack () {
     stack=new LinkedList();
}

public void newEntry () {
     StringBuffer bufferString=new StringBuffer();
     stack.addLast(bufferString);
//System.out.println("buffer new entry");
}


public void push (StringBuffer bufferString) {
     stack.addLast(bufferString);
}

public StringBuffer pop() {
//System.out.println("popping!");
     StringBuffer returnValue=(StringBuffer) stack.getLast();
     stack.removeLast();
     return returnValue;
}

public StringBuffer peek () {
     StringBuffer returnValue=(StringBuffer) stack.getLast();
     return returnValue;
}

public void append(String localString) {
       StringBuffer buffer=(StringBuffer) stack.getLast();
       buffer.append(localString);
//System.out.println("buffer appended" + localString);
//System.out.println("buffer status" + buffer);


}

public String toString() {
     StringBuffer returnValue=(StringBuffer) stack.getLast();
     return returnValue.toString();   
}

public void clear() {
     stack.clear();
}

}